<template>
  <v-navigation-drawer
    v-model="isCartDrawerOpen"
    temporary
    fixed
    right
    :class="[
      {
        'dark-black-bg res-quarter-width cart-drawer':
          $vuetify.breakpoint.mdAndUp,
      },
      'dark-black-bg res-width cart-drawer',
    ]"
  >
    <v-row>
      <v-col class="pt-0">
        <v-row>
          <v-col cols="12" class="text-right pt-10">
            <v-btn icon @click="closeCartDrawer">
              <v-icon> mdi-close</v-icon>
            </v-btn>
          </v-col>
          <v-col
            v-if="
              cartItems.length === 0 && cartItemsCF.length === 0
            "
            cols="12"
            class="d-flex justify-center mt-16"
          >
            <v-img :src="box" max-width="98" max-height="98" />
          </v-col>
          <v-col cols="12">
            <v-row
              v-if="
                cartItems.length === 0 &&
                  cartItemsCF.length === 0
              "
              class="d-flex justify-center"
            >
              <v-col cols="12">
                <p
                  
                  class="box-title-text text-center"
                >
                  {{ $t('common.addToSideBox') }}
                </p>
              </v-col>
            </v-row>

            <!-- PICK FOR ME BUTTON -->
            <v-row
              v-if="
                cartItems.length === 0 &&
                  cartItemsCF.length === 0
              "
            >
              <v-col cols="12" class="d-flex justify-center item-center align-center">
                <v-btn
                
                  class="
                                            mt-2
                                            lowercase
                                            br-0
                                            pa-5
                                            font-syne-bold
                                            br-15
                                        "
                  color="badge"
                  @click="goToPage(menus.HOWPICKFORMEWORKS.id)"
                >
                  {{ $t('buttons.pickForMeBtn') }}
                </v-btn>
              </v-col>
            </v-row>
            <div
              v-else-if="
                cartItems.length > 0 && cartItemsCF.length === 0 // enable return box
              "
            >
              <!-- SUBSCRIBED PLAN -->
              <v-row>
                <v-col md="10" cols="10" offset="1">
                  <v-col class="pl-0">
                    <h3
                      v-if="planDetails"
                      class="font-syne-bold"
                    >
                      {{ planDetails.name }}
                    </h3>
                    <h3 v-else class="font-syne-bold">
                      {{ $t('common.yourBox') }}
                    </h3>
                    <!-- <p class="plan-text mb-1">
                                            1 x VIP /
                                            <span class="plan-white-text"
                                                >4 x Luxury & Designer</span
                                            >
                                        </p> -->
                  </v-col>
                  <v-divider />
                </v-col>
              </v-row>

              <v-row
                v-for="(i, items) of cartItems"
                :key="'cart-' + items"
              >
                <v-col cols="3" offset="1">
                  <v-img v-if="i.image" :src="i.image.url" />
                </v-col>
                <v-col cols="5">
                  <p class="product-title-text mb-1">
                    {{ i.brand.name }} {{ i.name }}
                  </p>
                  <!-- <p class="product-desc-text mb-1">
                                        {{ i.size.name }} / {{ i.type.name }}
                                    </p> -->
                  <p class="product-desc-text mb-1">
                    {{ i.option.name }}
                  </p>
                  <p class="product-desc-text mb-1">
                    {{ currencyName }}
                    {{ i.price[currency].price }}
                  </p>
                </v-col>
                <v-col>
                  <v-btn
                    icon
                    :disabled="deleteItem.includes(i.id)"
                    @click="removeFromBox(i.id)"
                  >
                    <v-icon>mdi-close</v-icon>
                  </v-btn>
                </v-col>
              </v-row>

              <!-- TOTAL AMOUNT -->
              <v-row>
                <v-col md="10" cols="10" offset="1">
                  <v-divider />

                  <!-- ITEMS COUNT -->
                  <!-- <v-row>
                                        <v-col cols="6" class="pb-0">
                                            <p
                                                class="cart-text text-white mb-0"
                                            >
                                                {{ $t('cart.items') }}
                                            </p>
                                        </v-col>
                                        <v-col cols="6" class="text-right pb-0">
                                            <p
                                                class="cart-text text-white mb-0"
                                            >
                                                {{ cartItems.length }}/4
                                            </p>
                                        </v-col>
                                    </v-row> -->

                  <!-- ITEMS VALUE -->
                  <v-row>
                    <v-col cols="6" class="pb-0">
                      <p
                        class="
                                                    cart-text
                                                    text-white
                                                    mb-0
                                                "
                      >
                        {{ $t('cart.retailValue') }}
                      </p>
                    </v-col>
                    <v-col cols="6" class="text-right pb-0">
                      <p
                        class="
                                                    cart-text
                                                    text-white
                                                    mb-0
                                                "
                      >
                        {{ currencyName }}
                        {{ getTotalCartPrice }}
                        {{ $t('common.of') }}
                        {{ currencyName }}
                        {{
                          planDetails.purchase_amount
                        }}
                      </p>
                    </v-col>
                  </v-row>

                  <!-- RETAIL VALUE PROGRESS BAR -->
                  <v-row>
                    <v-col>
                      <v-progress-linear
                        :value="
                          getRetailValuePercentage
                        "
                        disabled
                        color="red"
                        height="10"
                      />
                    </v-col>
                  </v-row>

                  <!-- REMARKS -->
                  <v-row>
                    <v-col cols="9">
                      <p class="font-metropolis">
                        {{ $t('orders.remarks') }}
                        {{ currencyName }}
                        {{
                          planDetails.purchase_amount
                        }}
                        {{ $t('orders.remarks2') }}
                      </p>
                    </v-col>
                    <v-col class="d-flex justify-end">
                      <v-tooltip
                        v-model="extraFeeTooltip"
                        right
                      >
                        <template
                          v-slot:activator="{
                            on,
                            attrs,
                          }"
                        >
                          <v-btn
                            icon
                            small
                            v-bind="attrs"
                            v-on="on"
                          >
                            <v-icon
                              color="lighten-1"
                            >
                              mdi-information-outline
                            </v-icon>
                          </v-btn>
                        </template>
                        <span>Programmatic tooltip</span>
                      </v-tooltip>
                    </v-col>
                  </v-row>

                  <!-- CART FEE -->
                  <!-- <v-row v-if="surcharges">
                                        <v-col cols="6" class="pt-0 pb-1">
                                            <p class="cart-text text-white">
                                                {{ $t('cart.extraFee') }}
                                                <v-tooltip
                                                    v-model="extraFeeTooltip"
                                                    right
                                                >
                                                    <template
                                                        v-slot:activator="{
                                                            on,
                                                            attrs,
                                                        }"
                                                    >
                                                        <v-btn
                                                            icon
                                                            x-small
                                                            v-bind="attrs"
                                                            v-on="on"
                                                        >
                                                            <v-icon
                                                                color="badge lighten-1"
                                                            >
                                                                mdi-information-outline
                                                            </v-icon>
                                                        </v-btn>
                                                    </template>
                                                    <span
                                                        >Programmatic
                                                        tooltip</span
                                                    >
                                                </v-tooltip>
                                            </p>
                                        </v-col>
                                        <v-col
                                            cols="6"
                                            class="text-right pt-0 pb-1"
                                        >
                                            <p class="cart-text text-red">
                                                {{ currencyName }}
                                                {{ surcharges }}
                                            </p>
                                        </v-col>
                                    </v-row> -->

                  <!-- CART TOTAL AMOUNT -->
                  <!-- <v-row>
                                        <v-col cols="6" class="pt-1 pb-1">
                                            <h3>
                                                {{ $t('cart.total') }}
                                            </h3>
                                        </v-col>
                                        <v-col
                                            cols="6"
                                            class="text-right pt-1 pb-1"
                                        >
                                            <h3>
                                                {{ currencyName }}
                                                {{
                                                    getTotalCartPrice +
                                                    surcharges
                                                }}
                                            </h3>
                                        </v-col>
                                    </v-row> -->

                  <!-- CHECKOUT BUTTON -->
                  <v-row>
                    <v-col>
                      <v-btn
                        class="
                                                    lowercase
                                                    br-0
                                                    pl-10
                                                    pr-10
                                                    font-syne-bold
                                                "
                        color="badge"
                        block
                        large
                        :loading="isButtonDisabled"
                        :disabled="isButtonDisabled"
                        @click="goCheckout"
                      >
                        {{
                          $t('buttons.checkoutBtn')
                        }}
                      </v-btn>
                    </v-col>
                  </v-row>
                </v-col>
              </v-row>
            </div>
            <div
              v-else-if="
                cartItems.length > 0 && cartItemsCF.length > 0 // enable return box
              "
            >
              <v-row>
                <v-col cols="10" offset="1">
                  <v-expansion-panels v-model="panel">
                    <v-expansion-panel
                      v-for="(item, i) in 1"
                      :key="i"
                    >
                      <v-expansion-panel-header>
                        {{ $t('common.holdingItems') }}
                      </v-expansion-panel-header>
                      <v-expansion-panel-content>
                        <v-row
                          v-for="(
                            cf, items
                          ) of cartItemsCF"
                          :key="'cart-' + items"
                        >
                          <v-col cols="5">
                            <v-img
                              v-if="cf.image"
                              :src="cf.image.url"
                            />
                          </v-col>
                          <v-col cols="7">
                            <p
                              class="
                                                                product-title-text
                                                                mb-1
                                                            "
                            >
                              {{ cf.brand.name }}
                              {{ cf.name }}
                            </p>
                            <p
                              class="
                                                                product-desc-text
                                                                mb-1
                                                            "
                            >
                              {{ cf.variant }}
                            </p>
                            <p
                              class="
                                                                product-desc-text
                                                                mb-1
                                                            "
                            >
                              {{ currencyName }}
                              {{
                                cf.price[
                                  currency
                                ].price
                              }}
                            </p>
                          </v-col>
                        </v-row>
                      </v-expansion-panel-content>
                    </v-expansion-panel>
                  </v-expansion-panels>
                  <v-divider />
                </v-col>
              </v-row>
              <v-row>
                <v-col md="10" cols="10" offset="1">
                  <v-col class="pl-0">
                    <h3
                      v-if="planDetails"
                      class="font-syne-bold"
                    >
                      {{ planDetails.name }}
                    </h3>
                    <h3 v-else class="font-syne-bold">
                      {{ $t('common.yourBox') }}
                    </h3>
                    <!-- <p class="plan-text mb-1">
                                            1 x VIP /
                                            <span class="plan-white-text"
                                                >4 x Luxury & Designer</span
                                            >
                                        </p> -->
                  </v-col>
                  <v-divider />
                </v-col>
              </v-row>
              <v-row
                v-for="(i, items) of cartItems"
                :key="'cart-' + items"
              >
                <v-col cols="3" offset="1">
                  <v-img v-if="i.image" :src="i.image.url" />
                </v-col>
                <v-col cols="5">
                  <p class="product-title-text mb-1">
                    {{ i.brand.name }}
                    {{ i.name }}
                  </p>
                  <!-- <p class="product-desc-text mb-1">
                                        {{ i.size.name }} / {{ i.type.name }}
                                    </p> -->
                  <p class="product-desc-text mb-1">
                    {{ i.option.name }}
                  </p>
                  <p class="product-desc-text mb-1">
                    {{ currencyName }}
                    {{ i.price[currency].price }}
                  </p>
                </v-col>
                <v-col>
                  <v-btn
                    icon
                    @click="removeFromBox(i.id)"
                  >
                    <v-icon>mdi-close</v-icon>
                  </v-btn>
                </v-col>
              </v-row>
              <v-row>
                <v-col cols="5" offset="1" class="pb-0">
                  <p class="cart-text text-white mb-0">
                    {{ $t('cart.retailValue') }}
                  </p>
                </v-col>
                <v-col class="text-right pb-0 mr-8">
                  <p class="cart-text text-white mb-0">
                    {{ currencyName }}
                    {{ getTotalCartPrice }}
                    {{ $t('common.of') }}
                    {{ currencyName }}
                    {{ planDetails.purchase_amount }}
                  </p>
                </v-col>
              </v-row>

              <!-- RETAIL VALUE PROGRESS BAR -->
              <v-row>
                <v-col cols="10" offset="1">
                  <v-progress-linear
                    :value="getRetailValuePercentage"
                    disabled
                    color="red"
                    height="10"
                  />
                </v-col>
              </v-row>

              <!-- REMARKS -->
              <v-row>
                <v-col cols="8" offset="1">
                  <p class="font-metropolis">
                    {{ $t('orders.remarks') }}
                    {{ currencyName }}
                    {{ planDetails.purchase_amount }}
                    {{ $t('orders.remarks2') }}
                  </p>
                </v-col>
                <v-col class="d-flex justify-end mr-8">
                  <v-tooltip v-model="extraFeeTooltip" right>
                    <template
                      v-slot:activator="{ on, attrs }"
                    >
                      <v-btn
                        icon
                        small
                        v-bind="attrs"
                        v-on="on"
                      >
                        <v-icon color="lighten-1">
                          mdi-information-outline
                        </v-icon>
                      </v-btn>
                    </template>
                    <span>Programmatic tooltip</span>
                  </v-tooltip>
                </v-col>
              </v-row>

              <!-- CART FEE -->
              <!-- <v-row v-if="surcharges">
                                        <v-col cols="6" class="pt-0 pb-1">
                                            <p class="cart-text text-white">
                                                {{ $t('cart.extraFee') }}
                                                <v-tooltip
                                                    v-model="extraFeeTooltip"
                                                    right
                                                >
                                                    <template
                                                        v-slot:activator="{
                                                            on,
                                                            attrs,
                                                        }"
                                                    >
                                                        <v-btn
                                                            icon
                                                            x-small
                                                            v-bind="attrs"
                                                            v-on="on"
                                                        >
                                                            <v-icon
                                                                color="badge lighten-1"
                                                            >
                                                                mdi-information-outline
                                                            </v-icon>
                                                        </v-btn>
                                                    </template>
                                                    <span
                                                        >Programmatic
                                                        tooltip</span
                                                    >
                                                </v-tooltip>
                                            </p>
                                        </v-col>
                                        <v-col
                                            cols="6"
                                            class="text-right pt-0 pb-1"
                                        >
                                            <p class="cart-text text-red">
                                                {{ currencyName }}
                                                {{ surcharges }}
                                            </p>
                                        </v-col>
                                    </v-row> -->

              <!-- CART TOTAL AMOUNT -->
              <!-- <v-row>
                                        <v-col cols="6" class="pt-1 pb-1">
                                            <h3>
                                                {{ $t('cart.total') }}
                                            </h3>
                                        </v-col>
                                        <v-col
                                            cols="6"
                                            class="text-right pt-1 pb-1"
                                        >
                                            <h3>
                                                {{ currencyName }}
                                                {{
                                                    getTotalCartPrice +
                                                    surcharges
                                                }}
                                            </h3>
                                        </v-col>
                                    </v-row> -->

              <!-- CHECKOUT BUTTON -->
              <v-row>
                <v-col cols="10" offset="1">
                  <v-btn
                    class="
                                            lowercase
                                            br-0
                                            pl-10
                                            pr-10
                                            font-syne-bold
                                        "
                    color="badge"
                    block
                    large
                    :loading="isButtonDisabled"
                    :disabled="isButtonDisabled"
                    @click="goCheckout"
                  >
                    {{ $t('buttons.checkoutBtn') }}
                  </v-btn>
                </v-col>
              </v-row>
            </div>
            <!-- RETURN BOX -->
            <div v-else>
              <!-- CURRENT ORDER ITEMS -->
              <v-row>
                <v-col cols="10" offset="1">
                  <v-expansion-panels v-model="panel">
                    <v-expansion-panel
                      v-for="(item, i) in 1"
                      :key="i"
                    >
                      <v-expansion-panel-header>
                        {{ $t('common.holdingItems') }}
                      </v-expansion-panel-header>
                      <v-expansion-panel-content>
                        <v-row
                          v-for="(
                            cf, items
                          ) of cartItemsCF"
                          :key="'cart-' + items"
                        >
                          <v-col cols="5">
                            <v-img
                              v-if="cf.image"
                              :src="cf.image.url"
                            />
                          </v-col>
                          <v-col cols="7">
                            <p
                              class="
                                                                product-title-text
                                                                mb-1
                                                            "
                            >
                              {{ cf.brand.name }}
                              {{ cf.name }}
                            </p>
                            <p
                              class="
                                                                product-desc-text
                                                                mb-1
                                                            "
                            >
                              {{ cf.variant }}
                            </p>
                            <p
                              class="
                                                                product-desc-text
                                                                mb-1
                                                            "
                            >
                              {{ currencyName }}
                              {{
                                cf.price[
                                  currency
                                ].price
                              }}
                            </p>
                          </v-col>
                        </v-row>
                      </v-expansion-panel-content>
                    </v-expansion-panel>
                  </v-expansion-panels>
                  <v-divider />
                </v-col>
              </v-row>
              <v-row v-if="cartItemsCF[0].status !== 8">
                <v-col
                  cols="12"
                  class="d-flex justify-center mt-16"
                >
                  <v-img
                    :src="box"
                    max-width="98"
                    max-height="98"
                  />
                </v-col>
                <v-col cols="12">
                  <p class="box-title-text text-center">
                    {{ $t('common.returnBox') }}
                  </p>
                </v-col>
              </v-row>
              <v-row v-if="cartItemsCF[0].status !== 8">
                <v-col cols="10" offset="1">
                  <v-expansion-panels v-model="menu1">
                    <v-expansion-panel>
                      <v-expansion-panel-header
                        class="font-metropolis-regular"
                      >
                        {{
                          deliveryDate != ''
                            ? formatDate(
                              deliveryDate
                            )
                            : $t(
                              'form.deliveryDate.text'
                            )
                        }}
                      </v-expansion-panel-header>
                      <v-expansion-panel-content>
                        <client-only>
                          <date-picker
                            v-model="deliveryDate"
                            format="yyyy-MM-dd"
                            :disabled-dates="
                              disabledDates
                            "
                            :inline="true"
                            @selected="
                              menu1 = false
                            "
                          />
                        </client-only>
                      </v-expansion-panel-content>
                    </v-expansion-panel>
                  </v-expansion-panels>
                </v-col>
              </v-row>
              <v-form
                v-if="cartItemsCF[0].status !== 8"
                v-show="pageLoaded"
                ref="returnBoxForm"
                lazy-validation
                @submit.prevent
              >
                <!-- DELIVERY TIME -->
                <v-row v-if="cartItemsCF[0].status !== 8">
                  <v-col cols="10" offset="1">
                    <v-select
                      ref="deliveryTime"
                      v-model="form.deliveryTime.value"
                      :label="
                        $t('form.deliveryTime.text')
                      "
                      :items="timeslots"
                      item-text="name"
                      item-value="id"
                      :error-messages="
                        form.deliveryTime.error
                      "
                      :rules="[requiredRules]"
                    >
                      <template v-slot:append>
                        <v-icon>
                          mdi-chevron-down
                        </v-icon>
                      </template>
                    </v-select>
                  </v-col>
                </v-row>
                <v-row v-if="cartItemsCF[0].status !== 8">
                  <v-col cols="10" offset="1">
                    <v-btn
                      class="
                                                lowercase
                                                br-0
                                                pl-10
                                                pr-10
                                                font-syne-bold
                                            "
                      color="badge"
                      block
                      large
                      :loading="isButtonDisabled"
                      :disabled="isButtonDisabled"
                      @click="
                        validateForm(
                          cartItemsCF[0].orderId
                        )
                      "
                    >
                      {{
                        $t('buttons.returnBoxBtn')
                      }}
                    </v-btn>
                  </v-col>
                </v-row>
              </v-form>
            </div>
          </v-col>
        </v-row>
      </v-col>
    </v-row>
  </v-navigation-drawer>
</template>

<script lang="ts">
import { Vue, Component } from 'vue-property-decorator'
import { mapGetters } from 'vuex'
import moment from 'moment'

@Component({
    computed: mapGetters({
        menus: 'menu/getMenu',
        menuDashboard: 'menu/getMenuDashboard',
        cartDrawer: 'drawerbar/getCartDrawer',
        currency: 'currency/getCurrency',
        currencyName: 'currency/getCurrencyName',
        cartItems: 'cart/getCartItems',
        cartItemsCF: 'cart/getCartItemsCF',
        cartPrice: 'cart/getCartPrice',
        retailValue: 'cart/getRetailValue',
        surcharges: 'cart/getSurcharges',
        planDetails: 'subscription/getPlanDetails',
        shippingAddress: 'user/getShippingAddress',
        currentOrder: 'cart/getCurrentOrder',
    }),
})
export default class CartDrawer extends Vue {
    // Data
    $refs!: { returnBoxForm: HTMLFormElement }
    ref: any = this.$refs
    pageLoaded: boolean = false
    formHasErrors: boolean = false
    orderDisabled: boolean = true
    menus!: any
    menuDashboard!: any
    planDetails!: any
    cartDrawer!: boolean
    cartPrice!: Function
    retailValue!: Function
    currency!: number
    currencyName!: string
    shippingAddress!: any
    extraFeeTooltip: Boolean = false
    box: String = require('~/assets/images/cartbox.png')
    isRemoveButtonDisabled: boolean = false
    isButtonDisabled: boolean = false
    deleteItem: any = []
    panel: number = 0
    form: { [key: string]: any } = {
        deliveryTime: {
            value: '',
            error: null,
            requestKey: 'delivery_time',
        },
    }

    timeslots: any = []
    holidays: any = []
    todayDate: any = new Date().setDate(new Date().getDate())
    tomorrowDate: any = new Date(this.todayDate)
    disabledDates: any = {
        to: this.tomorrowDate,
        dates: this.holidays,
        days: [6, 0], // Disable Saturday's and Sunday's
    }

    menu1: any = false
    deliveryDate: any = ''

    // Rules
    requiredRules(v: string) {
        if (v) {
            return true
        } else {
            return this.$t('form.validation.required')
        }
    }

    // Computed
    get getTotalCartPrice() {
        return this.cartPrice(this.currency)
    }

    get getRetailValuePercentage() {
        const amount = 3000
        return this.retailValue(amount, this.currency)
    }

    get isCartDrawerOpen() {
        return this.cartDrawer
    }

    set isCartDrawerOpen(value: boolean) {
        this.$store.commit('drawerbar/setCartDrawer', value)
    }

    // Methods
    closeCartDrawer() {
        this.$store.commit('drawerbar/setCartDrawer', false)
    }

    async removeFromBox(product: any = {}) {
        // push product id to delete array
        if (!this.deleteItem.includes(product)) {
            this.deleteItem.push(product)
        }

        // delete from cart
        const response = await this.$api.cart.remove(product, 1)

        if (response.data) {
            this.$store.dispatch('cart/removeFromCart', product)
            const val: {} = {
                text: this.$t('notification.cart.removed'),
                color: 'green',
                icon: 'mdi-check',
            }
            this.$store.dispatch('snackbar/displaySnackBar', val)

            // remove product id from delete array
            if (this.deleteItem.includes(product)) {
                const index = this.deleteItem.indexOf(product)
                this.deleteItem.splice(index, 1)
            }
        } else {
            const val: {} = {
                text: this.$t('notification.cart.removed_failed'),
                color: 'red',
                icon: 'mdi-alert',
            }
            this.$store.dispatch('snackbar/displaySnackBar', val)
        }
    }

    validateForm(orderId: number) {
        if (typeof this.$refs === 'undefined') {
            return
        }

        setTimeout(() => {
            const valid = this.$refs.returnBoxForm.validate()

            if (valid) {
                if (!this.deliveryDate) {
                    const val = {
                        text: this.$t('notification.date.required'),
                        color: 'white',
                        icon: 'mdi-alert',
                    }
                    this.$store.dispatch('snackbar/displaySnackBar', val)
                    this.isButtonDisabled = false
                } else {
                    this.goReturnBox(orderId)
                }
            }
        }, 300)
    }

    goReturnBox(orderId: number) {
        this.isButtonDisabled = true

        // return cart api
        this.$api.timeslot
            .allocate(
                orderId,
                moment(this.deliveryDate).format('yyyy-MM-DD'),
                this.form.deliveryTime.value
            )
            .then(() => {
                const val = {
                    text: this.$t('notification.return.success'),
                    color: 'green',
                    icon: 'mdi-check',
                }
                this.$store.dispatch('snackbar/displaySnackBar', val)

                this.isButtonDisabled = false
            })
            .catch((error) => {
                // Get errors object
                if (error.response.status === 400) {
                    const val = {
                        text: error.response.data.message,
                        color: 'red',
                        icon: 'mdi-alert',
                    }
                    this.$store.dispatch('snackbar/displaySnackBar', val)
                }
                // Reopen button
                this.isButtonDisabled = false
            })
    }

    goCheckout() {
        this.$router.push(this.menus.CHECKOUT.path)
    }

    formatDate(date) {
        return moment(date).format('yyyy-MM-DD')
    }

    async getTimeslots() {
        const timeslots = await this.$api.timeslot.getTimeslots()
        if (timeslots.data.data.length > 0) {
            for (const key of timeslots.data.data) {
                // return timeslots
                if (key.type_id === 2) {
                    const convertStartTime = moment().format(
                        'YYYY-MM-DD ' + key.start_time
                    )
                    const newStartTime = moment(convertStartTime)
                        .add(8, 'hours')
                        .format('HH:mm')

                    const convertEndTime = moment().format(
                        'YYYY-MM-DD ' + key.end_time
                    )
                    const newEndTime = moment(convertEndTime)
                        .add(8, 'hours')
                        .format('HH:mm')

                    const suffixStart =
                        parseInt(newStartTime) >= 12 ? 'PM' : 'AM'
                    const suffixEnd = parseInt(newEndTime) >= 12 ? 'PM' : 'AM'
                    const timeStart =
                        ((parseInt(newStartTime) + 11) % 12) + 1 + suffixStart
                    const timeEnd =
                        ((parseInt(newEndTime) + 11) % 12) + 1 + suffixEnd

                    const obj = {
                        id: key.id,
                        name: timeStart + ' - ' + timeEnd,
                    }
                    this.timeslots.push(obj)
                }
            }
        }
    }

    async getHolidays() {
        const holidays = await this.$api.holiday.getHolidays()
        if (holidays.data.data.length > 0) {
            for (const key of holidays.data.data) {
                this.holidays.push(new Date(key.from))
            }
        }
    }

    goToPage (id: Number) {
      switch (id) {
        case this.menus.HOWPICKFORMEWORKS.id:
          this.$router.push(this.menus.HOWPICKFORMEWORKS.path)
          break

        default:
          this.$router.push('/')
          break
      }
    }

    mounted() {
        this.getTimeslots()
        this.getHolidays()
        if (typeof this.$refs !== 'undefined') {
            this.ref = this.$refs
            this.pageLoaded = true
        }
    }
}
</script>
